#include <stdio.h>
#include <stdlib.h> 

#define ARR_SIZE_R 15			// 迭  ũ
#define ARR_SIZE_C 15			// 迭  ũ
#define WIN_NUMBER 5			//  ¸ 

int display(void);			// ù ȭ ϴ Լ
int play_omok(void);			//  ϴ Լ	
int set_board(char [][ARR_SIZE_C]);			//  ʱⰪ Էϴ Լ
int show_board(char [][ARR_SIZE_C]);			//  ϴ Լ
int input_player(int*, int*, int*, char [][ARR_SIZE_C]);			// ÷̾ ġ Էϴ Լ
int check_whether(int, int, char [][ARR_SIZE_C]);			// Է ġ   ˻ϴ Լ
int check_33(int x, int y);			//  Ģ (3*3) üũϴ Լ
int check_44(int x, int y);			//  Ģ (4*4) üũϴ Լ
int check_row(char, int, int, char [][ARR_SIZE_C]);			//  ˻ϴ Լ
int	check_column(char, int, int, char [][ARR_SIZE_C]);			//  ˻ϴ Լ
int	check_Ldiagonal(char, int, int, char [][ARR_SIZE_C]);			// ʴ밢 ˻ϴ Լ
int	check_Rdiagonal(char, int, int, char [][ARR_SIZE_C]);			// ʴ밢 ˻ϴ Լ
int check_winner(int, int, int, char[][ARR_SIZE_C]);			// ¸  ˻ϴ Լ
int replay_game(void);			//     Ȯϴ Լ

//  Լ
int main(void){
	display();			// ʱ ȭ ϴ Լ

	play_omok();		//   ϴ Լ

	return 0;
}

// ʱ ȭ
int display(void){
	printf("  =========================================\n");
	printf("           (%d X %d)\n", ARR_SIZE_R, ARR_SIZE_C);
	printf("  =========================================\n");

	return 0;
}

//   Լ
int play_omok(void){
	char omok_board[ARR_SIZE_R][ARR_SIZE_C];			//  迭 
	int index_row=0, index_column=0, reset = 1, playEnd=1, player, stone, win;			// Ÿ  ( ε,  ε, ʱȭ, ӽ, ÷̾,  , ¸)

	while(playEnd)			// playEnd 1   
	{
		if(reset)			//   Ҷ ʱȭ  '' ̶
		{
			set_board(omok_board);			//  ʱȭϴ Լ ȣ
			player = 1;				// ÷̾ 
			stone = 1;			// ݺ ݺ( )
			win = 0;			// ¸  
			reset = 0;			// ʱȭ 
			
		}		
		show_board(omok_board);			//  
		
		if(win == 0)			// ¸ ڰ   
		{
			input_player(&player, &index_row, &index_column, omok_board);			// ÷̾ Էϴ Լ ȣ
			
			if(stone >= (WIN_NUMBER*2)-1)				//      ̻϶ ¸  ˻
				win = check_winner(player, index_row-1, index_column-1, omok_board);		// ¸  ˻ϴ Լ ȣ
		}
		else			// ¸ ڰ  
		{
			printf("%s ¸ Ͽϴ.\n\n", (win == 1)?"":"Ͼᵹ");		// ¸ ޽ 
	
			play = replay_game();			//     Ȯϴ Լ ȣ

			if(playEnd == 1)			//   
			{
				reset = 1;			// ʱȭ   1 Ͽ Ǵ  ʱȭ
			}
		}

		if(win == 0 && player == 1)				// ÷̾(1) Է   ڷ 
			player = 2;
		else if(win == 0 && player == 2)		// ÷̾(2) Է   ڷ 
			player = 1;

		stone++;				// ݺ ī

		if(playEnd == 1)				//   
			system("cls");			// ȭ 
	}

	return 0;	
}

//  ʱⰪ Է Լ
int set_board(char omok_board[][ARR_SIZE_C])
{
	int nIdx_r, nIdx_c;

	for(nIdx_r=0; nIdx_r<ARR_SIZE_R; nIdx_r++)
	{
		for(nIdx_c=0; nIdx_c<ARR_SIZE_C; nIdx_c++)
		{
			omok_board[nIdx_r][nIdx_c] = '_';			//  迭  '_' ڷ 
		}
	}

	return 0;
}

//   Լ
int show_board(char omok_board[][ARR_SIZE_C])
{
	int nIdx_r, nIdx_c, nCnt;

	printf("  -----------------------------------------\n");
	printf"                  Ȳ");
	printf("  -----------------------------------------\n");

	for(nCnt=1; nCnt<=ARR_SIZE_C; nCnt++)			//  ȣ 
	{	
		if(nCnt == 1)
		{
			printf("    ");
		}

		printf("%3d ", nCnt);
	}

	printf("\n");

	for(nIdx_r=0; nIdx_r<ARR_SIZE_R; nIdx_r++)			//  ȣ 迭  
	{
		printf("%3d ", nIdx_r+1);

		for(nIdx_c=0; nIdx_c<ARR_SIZE_C; nIdx_c++)
		{
			printf(" %2c ", omok_board[nIdx_r][nIdx_c]);
		}
		printf("\n");
	}

	return 0;
}

//    Է Լ
int input_player(int* player, int* pIdx_r, int* pIdx_c, char omok_board[][ARR_SIZE_C])
{
	int inFlag=0;			// Է    Ȯ 

	while(inFlag == 0)			// ߸  ġ  Էϸ  Է
	{
		printf("\n%s Է ġ ԷϽÿ[ ] : ", (*player == 1)?"[X]":"Ͼ[O]");			// 翡  Է  
		scanf("%d %d", pIdx_r, pIdx_c);			//   Է

		inFlag = check_whether(*pIdx_r, *pIdx_c, omok_board);			// Է ġ 迭 Է  ˻

		if(inFlag)			// Է  
			omok_board[*pIdx_r-1][*pIdx_c-1] = (*player == 1)?'X':'O';		// ش  ڸ 迭 ش ġ Է
		else				// ߸ ġ Է 
			printf("Է  ̹  ְų  ϴ.");
	}

	return 0;
}

// Է   ˻ Լ
int check_whether(int pIdx_r, int pIdx_c, char omok_board[][ARR_SIZE_C])
{
	int inFlag=0;			// Է   ˻ 

	if((pIdx_r-1>=0 && pIdx_r-1<ARR_SIZE_R) && (pIdx_c-1>=0 && pIdx_c-1<ARR_SIZE_C))			// 迭  ̰
	{
		if(omok_board[pIdx_r-1][pIdx_c-1] == '_')			//  迭    
			inFlag=1;			// ÷  1
		else					//  迭   ڰ ƴ 
			inFlag = 0;		// ÷  0
	}
	else		//   
	{
		inFlag = 0;			// ÷  0
	}

	return inFlag;		// ÷  Ѱ
}

// ¸  ˻ Լ
int check_winner(int player, int index_row, int index_column, char omok_board[][ARR_SIZE_C])
{
	char cStone = (player == 1)?'X':'O';			//   ڸ Ư  Է
	int win=0;			// ¸  

	if(player == 1)			// 1 ÷̾ 
	{
		//  ¸ ڿ  
		if((check_row(cStone, index_row, index_column, omok_board) == WIN_NUMBER) ||		//  ˻
			(check_column(cStone, index_row, index_column, omok_board) == WIN_NUMBER) ||			//  ˻
			(check_Ldiagonal(cStone, index_row, index_column, omok_board) == WIN_NUMBER) ||		// 밢1 ˻				
			(check_Rdiagonal(cStone, index_row, index_column, omok_board) == WIN_NUMBER))		// 밢2 ˻
		{
			win = 1;		
		}
	}
	else if(player == 2)			// 2 ÷̾ 
	{
		//  ¸ ڿ ų Ŭ 
		if((check_row(cStone, index_row, index_column, omok_board) >= WIN_NUMBER) ||		//  ˻
			(check_column(cStone, index_row, index_column, omok_board) >= WIN_NUMBER) ||			//  ˻
			(check_Ldiagonal(cStone, index_row, index_column, omok_board) >= WIN_NUMBER) ||		// 밢1 ˻				
			(check_Rdiagonal(cStone, index_row, index_column, omok_board) >= WIN_NUMBER))		// 밢2 ˻
		{
			win = 2;
		}
	}
	
	return win;
}

//  ˻ Լ
int check_row(char cStone, int index_row, int index_column, char omok_board[][ARR_SIZE_C])
{	
	int winCnt=0, pIdx_c, mIdx_c;

	pIdx_c = mIdx_c = index_column;			// 迭 ġ 

	while(omok_board[index_row][pIdx_c--] == cStone)		//   ˻
	{
		winCnt++;		// ӵ  ī 
	}
	while(omok_board[index_row][++mIdx_c] == cStone)		//   ˻
	{
		winCnt++;		// ӵ  ī 
	}

	//printf(" ˻ : %d\n", winCnt);

	return winCnt;
}

//  ˻ Լ
int check_column(char cStone, int index_row, int index_column, char omok_board[][ARR_SIZE_C])
{
	
	int winCnt=0, pIdx_r, mIdx_r;

	pIdx_r = mIdx_r = index_row;			// 迭 ġ 

	while(omok_board[mIdx_r--][index_column] == cStone)			//   ˻
	{
		winCnt++;		// ӵ  ī 
	}
	while(omok_board[++pIdx_r][index_column] == cStone)			//  Ʒ ˻
	{
		winCnt++;		// ӵ  ī 
	}

	//printf(" ˻ : %d\n", winCnt);

	return winCnt;
}

// 밢1 ˻ Լ
int check_Ldiagonal(char cStone, int index_row, int index_column, char omok_board[][ARR_SIZE_C])
{
	
	int winCnt=0, pIdx_r, mIdx_r, pIdx_c, mIdx_c;

	pIdx_r = mIdx_r = index_row;			// 迭 ġ 
	pIdx_c = mIdx_c = index_column;			// 迭 ġ 

	while(omok_board[mIdx_r--][mIdx_c--] == cStone)			// 밢   ˻
	{
		winCnt++;		// ӵ  ī 
	}
	while(omok_board[++pIdx_r][++pIdx_c] == cStone)			// 밢  Ʒ ˻
	{
		winCnt++;		// ӵ  ī 
	}

	//printf("밢1 ˻ : %d\n", winCnt);

	return winCnt;
}

// 밢2 ˻ Լ
int check_Rdiagonal(char cStone, int index_row, int index_column, char omok_board[][ARR_SIZE_C])
{
	
	int winCnt=0, pIdx_r, mIdx_r, pIdx_c, mIdx_c;

	pIdx_r = mIdx_r = index_row;			// 迭 ġ 
	pIdx_c = mIdx_c = index_column;			// 迭 ġ 

	while(omok_board[mIdx_r--][pIdx_c++] == cStone)			// 밢   ˻
	{
		winCnt++;		// ӵ  ī 
	}
	while(omok_board[++pIdx_r][--mIdx_c] == cStone)			// 밢  Ʒ ˻
	{
		winCnt++;		// ӵ  ī 
	}

	//printf("밢2 ˻ : %d\n", winCnt);

	return winCnt;
}

//     Լ
int replay_game(void)
{
	char cRetry;			//   Է 
	int reNum=0;		//    

	fflush(stdin);			//   

	printf("   Ͻðڽϱ?");
	
	do
	{
		printf(" Ͻ÷[Y(y)], Ϸ[N(n)] ֽʽÿ : ");
		scanf("%c", &cRetry);
	}
	while((cRetry != 'Y') && (cRetry != 'y') && (cRetry != 'N') && (cRetry != 'n'));		// Ȯ    ݺ

	printf("");

	if((cRetry == 'Y') || (cRetry == 'y'))		//  
	{
		reNum = 1;
	}
	else if((cRetry == 'N') || (cRetry == 'n'))		//  
	{
		printf("  մϴ.");

		reNum = 0;
	}

	return reNum;
}